<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Simple Player List - Updater</title>
<style type="text/css">
	body {
		background:#f1eade;
		font-family: Verdana, Arial, Sans-Serif;
		font-size:13px;
		}
</style>
</head>

<body>
<?php 
//--------------------------------------------------//
# Simple Player List by Flabaliki

# Run this file to update the config.php file.
//--------------------------------------------------//
$configFile = "config.php";

//List of all configuration settings.
$configSettings = array(
	"serverName", 
	"serverIP", 
	"passcode", 
	"enableFaces", 
	"faceGrid", 
	"faceGridWidth", 
	"enableRankColors",
	"faceSize", 
	"template", 
	"lastConnection"
);

//List of all configuration setting descriptions;
$configDescriptions = array(
	"serverName" => "# Enter the name of your server.", 
	"serverIP" => "# Enter the IP or domain of your server.\n# eg: 251.23.45.8 or server.mywebsite.com", 
	"passcode" => "# Enter your passcode here, this must be the same\n# as the one entered in your plugin config.yml file.", 
	"enableFaces" => "# This feature requires PHP GD, it will enable\n# the face of a users minecraft skin to display next\n# to their name on the list.", 
	"faceGrid" => "#REQUIRES \$enableFaces set to true;\n#This will display the online users in a grid formate\n#using only their faces, names will popup on hover.", 
	"faceGridWidth" => "#Number of faces to display on each row of the grid.\n#REQUIRES \$faceGrid set to true;", 
	"enableRankColors" => "#This will allow the use of colours in rank names.\n#These are the same colours you use in Minecraft chat.\n#Eg &e &f",
	"faceSize" => "#Size of the user faces in pixels.", 
	"template" => "# The following variables; [Name], [IP], [Players], \n# and [Slots] will be replaced by their respective content.\n# Put them in any order you would like, you can even remove\n# them completely.", 
	"lastConnection" => "# --------------------------------------------------------- #\n# DO NOT EDIT ANYTHING BELOW THIS LINE\n# --------------------------------------------------------- #"
);

//List of all configuration setting default values.
$configDefaultVals = array(
	"serverName" => "\$serverName = \"My Minecraft Server\";", 
	"serverIP" => "\$serverIP = \"localhost\";", 
	"passcode" => "\$passcode = \"abc123\";", 
	"enableFaces" => "\$enableFaces = false;", 
	"faceGrid" => "\$faceGrid = false;", 
	"faceGridWidth" => "\$faceGridWidth = 5;", 
	"enableRankColors" => "\$enableRankColors = true;",
	"faceSize" => "\$faceSize = 16;", 
	"template" => "\$template = \"[Name][IP][Players][Slots]\";", 
	"lastConnection" => "\$lastConnection = 0;"
);

$configSettingLocations = array(
	"serverName" => -1, 
	"serverIP" => -1, 
	"passcode" => -1, 
	"enableFaces" => -1, 
	"faceGrid" => -1, 
	"faceGridWidth" => -1, 
	"enableRankColors" => -1,
	"faceSize" => -1, 
	"template" => -1, 
	"lastConnection" => -1
);

if(isset($_POST['update'])){
	$lines = file($configFile) or die("Error: Can't open $configFile. The file either doesn't exist or the correct permissions. On Linux, chmod this file to 664 or 666.");
	$newConfig = $lines;
	
	//Find which variables are in the config file.
	foreach($configSettings as $index => $setting){
		foreach($lines as $lineNum => $line){
			if (preg_match_all ("/(\\$" . $setting . " = )/is",$line, $matches)){	
				$configSettingLocations[$setting] = $lineNum;
			}
		}	
	}
	
	//Place the ones that are missing.
	$count = 0;
	foreach($configSettingLocations as $setting => $pos){
		if($pos < 0){
			$newPos = 0;
			if($count > 0){$newPos = $configSettingLocations[$configSettings[$count - 1]];}
			array_splice($newConfig, $newPos + 1, 0, array("\n", $configDescriptions[$setting] . "\n", $configDefaultVals[$setting] . "\n"));
		}
		$count++;
	}
	
	//Convert array into a string
	$stringConfig = "";
	for($i = 0; $i < count($newConfig); $i++){
		$stringConfig .= $newConfig[$i];
	}
	
	//Open file for writing.
	$fh = fopen($configFile, 'w') or die("Error: Can't open $configFile. The file either doesn't exist or the correct permissions. On Linux, chmod this file to 664 or 666.");
	
	//Write to and close the file
	fwrite($fh, $stringConfig);
	fclose($fh);
	
	echo "<center>Config file successfully updated!<br/>It is <strong>strongly</strong> suggested that you now delete this file.</center>";
} else {
	echo "<table align=\"center\">\n
  \t<tr>\n
    \t\t<td><p>Click the button bellow when you are ready to update your config file.</p>\n
      \t\t<p>This will not erase any existing settings, only add new ones that exist.</p></td>\n
  \t\t</tr>\n
  \t<tr>\n
    \t\t<td align=\"center\"><form method=\"post\" action=\"#\">\n
        \t\t<input type=\"submit\" name=\"update\" value=\"Update config.php\" />\n
     \t\t</form></td>\n
  \t</tr>\n
</table>";	
}
	
?>
</body>
</html>